<?php
// The template for displaying Comments.

$rigid_commenter = wp_get_current_commenter();
$rigid_req = get_option('require_name_email');
$rigid_aria_req = ( $rigid_req ? " aria-required='true'" : '' );
?>
<div class="clear"></div>
<?php if (post_password_required()) : ?>
	<div id="comments">
		<p class="nopassword"><?php esc_html_e('This post is password protected. Enter the password to view any comments.', 'rigid'); ?></p>
	</div><!-- #comments -->
	<?php return; ?>
<?php endif; ?>

<div id="comments">
    <?php
    $rigid_comments_meta = rigid_comments_valid_for_post( get_the_ID() );
    ?>
    <?php if ( have_comments() && $rigid_comments_meta['valid_comments'] ) : ?>
		<h3 class="heading-title">
			<?php
			printf(_n('One thought on &ldquo;%2$s&rdquo;', '%1$s thoughts on &ldquo;%2$s&rdquo;', $rigid_comments_meta['valid_comments_count'], 'rigid'), number_format_i18n($rigid_comments_meta['valid_comments_count']), '<span>' . get_the_title() . '</span>');
			?>
		</h3>

		<?php if (get_comment_pages_count() > 1 && get_option('page_comments')) : ?>
			<div id="comment-nav-above">
				<div class="nav-previous"><?php previous_comments_link(esc_html__('&larr; Older Comments', 'rigid')); ?></div>
				<div class="nav-next"><?php next_comments_link(esc_html__('Newer Comments &rarr;', 'rigid')); ?></div>
			</div>
		<?php endif; ?>

		<ul class="commentlist">
			<?php
			wp_list_comments(array('callback' => 'rigid_comment'));
			?>
		</ul>

		<?php if (get_comment_pages_count() > 1 && get_option('page_comments')) : // are there comments to navigate through  ?>
			<div id="comment-nav-below">
				<div class="nav-previous"><?php previous_comments_link(esc_html__('&larr; Older Comments', 'rigid')); ?></div>
				<div class="nav-next"><?php next_comments_link(esc_html__('Newer Comments &rarr;', 'rigid')); ?></div>
			</div>
		<?php endif; ?>

		<?php
		if (!comments_open() && get_comments_number()) :
			?>
			<p class="nocomments"><?php esc_html_e('Comments are closed.', 'rigid'); ?></p>
		<?php endif; ?>

	<?php endif; ?>

	<?php comment_form(); ?>

</div><!-- #comments -->
