/**
 * Backend Rigid scripts
 */
(function ($) {
	"use strict";
	$(document).ready(function () {
       // $('#rigid-optionsframework .controls select').niceSelect();
		// Init wpColorPicker color picker for menu label colors
		$('input.rigid-menu-colorpicker').wpColorPicker();

        // Init wpColorPicker color picker for theme options
        $('input.rigid-theme-options-colorpicker').wpColorPicker({
            change: function(event, ui){
                $(this).closest('div.controls').find('div.rigid_font_preview p').css({color: ui.color});
			}
		});

		// Proper position featured images metaboxes
		var featured_img_meta = $('#postimagediv');
		var featured_imgs_arr = new Array();
		if (featured_img_meta.length) {
			for (var i = 6; i >= 2; i--) {
				featured_imgs_arr[i] = $('#rigid_featured_' + i);
				if (featured_imgs_arr[i].length) {
					featured_imgs_arr[i].detach().insertAfter(featured_img_meta);
				}
			}
		}

		// Proper position Portfolio Gallery Options metabox
		var prtfl_gallery_options_meta = $('#rigid_portfolio_cz');
		if (prtfl_gallery_options_meta.length && featured_img_meta.length) {
			prtfl_gallery_options_meta.detach().insertBefore(featured_img_meta);
		}

		// Proper position Product Gallery Type Options metabox
		var product_gallery_options_meta = $('#rigid_product_gallery_type');
		var product_gallery_meta = $('#woocommerce-product-images');
		if (product_gallery_options_meta.length && product_gallery_meta.length) {
			product_gallery_options_meta.detach().insertBefore(product_gallery_meta);
		}

		// Init fonticonpicker on menu edit
		$('#menu-to-edit a.item-edit').on('click', function () {
			$(this).parents("li.menu-item").find("input.rigid-menu-icons").fontIconPicker({
				source: rigid_back_js_params.font_awesome_icon_classes
			});
		});

		if (rigid_back_js_params.new_orders_push_notifications === 'yes' && typeof Notification !== "undefined" && Notification.permission === 'default') {
			$("#rigid-push-confirm").dialog({
				resizable: false,
				height: "auto",
				width: 400,
				modal: true,
				buttons: [
					{
						text: rigid_back_js_params.new_orders_push_notifications_allow_label,
						click: function () {
							$(this).trigger('rigid-push-confirm');
							$(this).dialog("close");
						}
					},
					{
						text: rigid_back_js_params.new_orders_push_notifications_cancel_label,
						click: function () {
							$(this).dialog("close");
						}
					}
				]
			});

			$(window).on('rigid-push-confirm', function () {
				Notification.requestPermission().then(function (result) {
					if (result === 'denied') {
						console.log('Permission wasn\'t granted. Allow a retry.');
						return;
					}
					if (result === 'default') {
						console.log('The permission request was dismissed.');
						return;
					}
				});
			});
		}
	});

	if (rigid_back_js_params.new_orders_push_notifications === 'yes') {
		window.addEventListener('load', function () {
			if (typeof Notification !== "undefined" && 'serviceWorker' in navigator) {
				navigator.serviceWorker.register(rigid_back_js_params.service_worker_path).then(function (registration) {
					// Registration was successful
					setInterval(function () {
						$.ajax({
							type: 'POST',
							data: {
								action: 'rigid_new_orders_notification'
							},
							url: ajaxurl,
							success: function (response) {
								if (response !== '') {
									var data = {
										title: response.title,
										body: response.body,
										icon: response.icon,
										data: { url: response.url },
									};

									registration.active.postMessage(data);
								}
							},
							complete: function () {
							}
						});
					}, 30000);
				}, function (err) {
					// registration failed :(
					console.log('ServiceWorker registration failed: ', err);
				});
			}
		});
	}
})(window.jQuery);